#pragma once

#include <time.h>
#include <stdbool.h>

struct peer
{
	int id;

	char* domain;
	char* tor_hidden_service;
	time_t last_successful_delivery;
	time_t last_failed_delivery;
	bool admin_disable_outbox;
	bool admin_disable_tor;

	time_t last_hidden_service_delivery;
	time_t last_tor_delivery;
};

void peer_model_init();

struct peer* peer_new();
struct peer* peer_from_id( int id );
struct peer* peer_from_domain( const char* domain );
struct peer* peer_create_from_domain( const char* domain );
void peer_save( struct peer* p );
void peer_free( struct peer* p );

